Subject: Re: cat /proc/net/tcp takes 0.5 seconds on x86_64

From: Eric Dumazet <[email-masked]>
Date: Thu, 28 Aug 2008 01:43:31 +0200

David Miller a écrit :
> From: Eric Dumazet <[email-masked]>
> Date: Thu, 28 Aug 2008 01:09:19 +0200
> 
>> Not really, I suspect commit (a7ab4b501f9b8a9dc4d5cee542db67b6ccd1088b [TCPv4]: Improve BH latency in /proc/net/tcp) is responsible for longer delays.
>> Note that its rather old :
>  ...
>> We used to disable bh once, while reading the table. This sucked.
>>
>> In case machine is handling trafic, we now are preemptable by softirqs
>> while reading /proc/net/tcp. Thats a good thing.
> 
> Yes, that would account for it, good spotting.
> 
>> By the way, I find Andi patch usefull. Same thing could be done for /proc/net/rt_cache.
> 
> Fair enough.  If you can cook up a quick rt_cache patch I'll toss it and
> Andi's patch into net-next so it can cook for a while.

Well, first patch I would like to submit is about letting netlink being able to be 
faster than /proc/net/tcp again :)

Thank you

[PATCH] tcp: speedup tcp hash table lookups for NETLINK

Avoid taking locks for empty buckets.

Signed-off-by: Eric Dumazet <[email-masked]>

diff --git a/net/ipv4/inet_diag.c b/net/ipv4/inet_diag.c
index c10036e..0fa690c 100644
--- a/net/ipv4/inet_diag.c
+++ b/net/ipv4/inet_diag.c
@@ -778,10 +778,13 @@ skip_listen_ht:
 
 	for (i = s_i; i < hashinfo->ehash_size; i++) {
 		struct inet_ehash_bucket *head = &hashinfo->ehash[i];
-		rwlock_t *lock = inet_ehash_lockp(hashinfo, i);
+		rwlock_t *lock;
 		struct sock *sk;
 		struct hlist_node *node;
 
+		if (hlist_empty(&head->chain) && hlist_empty(&head->twchain))
+			continue;
+		lock = inet_ehash_lockp(hashinfo, i);
 		if (i > s_i)
 			s_num = 0;